// A Checkers Program for Checkerboard.
// by Jonathan Kreuzer
// copyright 2005
// www.3dkingdoms.com
// I compiled it with MSVC++ 6.0, haven't tested it with other compilers

// You are welcome to alter this code in any way, but if you distribute anything that uses this code, it
// should also be open source, freely distributed, and include a notice that it uses this code. 

// Ideas on the otherhand are of course free, if any ideas in this source inspire you to write or alter your own 
// distinct code that's fine, it's still yours to do whatever you want with.

// This code is a simplifying of the full Gui 0.99 source that also includes code for its own GUI, 4pc and less endgame databases,
// So there my be some stuff still left in here that isn't being used. 

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <conio.h>
#include <memory.h>
#include <windows.h>

#define WHITE 2
#define BLACK 1 // Black == Red
#define EMPTY 0
#define BPIECE 1
#define WPIECE 2
#define BKING  5
#define WKING  6
#define INVALID 8
#define NONE 255
#define TIMEOUT 31000
#define DOUBLEJUMP 2000
#define HUMAN 128
#define MAKEMOVE 129
#define SEARCHED 127
#define MAX_SEARCHDEPTH 96
#define MAX_GAMEMOVES 2048
const int EXPERT_DEPTH = 52; // Max depth for each level

// GLOBAL VARIABLES... ugg, too many?
char *g_sNameVer = "Open-Gui Checkers 0.99", *g_sInfo;
float fMaxSeconds = 2.0f; // The number of seconds the computer is allowed to search
int g_bEndHard = FALSE; // Set to true to stop search after fMaxSeconds no matter what.
int g_MaxDepth = EXPERT_DEPTH; 
int nodes, nodes2, SearchDepth, g_SelectiveDepth;
char g_cCompColor = WHITE;
clock_t starttime, endtime;
int g_SearchingMove = 0, g_SearchEval = 0;   
int g_nDouble = 0, g_nMoves = 0; // Number of moves played so far in the current game
int bCheckerBoard = 0;
int *g_pbPlayNow, g_bStopNow = 0;
unsigned int HASHTABLESIZE = 680000; // 800,000 entries * 12 bytes per entry

void RunningDisplay ( int bestmove, int bSearching);
int hashing = 1;

#include "search.cpp"
// -----------------------
// Move Being Searched
// -----------------------
void inline RunningDisplay ( int bestMove, int bSearching )
	{
	char sTemp[4096];
	static int LastEval = 0, nps = 0;
	int j = 0;
	float fDiv =  float (clock () - starttime) * CLOCKS_PER_SEC / 1000;
	if ( fDiv > 0.0f) nps = int (float(nodes) / fDiv);
	if (abs (g_SearchEval) < 3000) LastEval = g_SearchEval;
	bestMove = g_Movelist[1].Moves[ bestMove ].SrcDst;
	char cCap = (bestMove>>12) ? 'x' : '-';
	j+=sprintf( sTemp+j, "Depth: %d/%d (%d/%d)   Eval: %d  ", SearchDepth, g_SelectiveDepth, g_SearchingMove, g_Movelist[1].nMoves, -LastEval);
	j+=sprintf (sTemp+j, "Move: %d%c%d   Time: %.2fs   KNodes: %d   KN/Sec: %d", FlipX (BoardLocTo32[bestMove&63])+1, cCap, FlipX (BoardLocTo32[(bestMove>>6)&63])+1, (fDiv/1000.0f), (nodes/1000), nps);
	strcpy (g_sInfo, sTemp);
	}
// ------------------------------------------
// This will interface CheckerBoard, you can get it at http://www.fierz.ch/
// ------------------------------------------
struct CBmove { int notused; };
int ConvertFromCB [16] = { 0, 0, 0, 0, 0, 2, 1, 0, 0, 6, 5, 0, 0, 0, 0, 0};
int ConvertToCB   [16] = { 0, 6, 5, 0, 0, 10,9, 0, 0, 0, 0, 0, 0, 0, 0, 0};

int WINAPI getmove(int board[8][8], int color, double maxtime, char str[1024], int *playnow, int info, int unused, struct CBmove *move)
{
static int nDraw = 0;
g_bEndHard = ( info&2 ) ? TRUE : FALSE;
if ( !bCheckerBoard )
	{ // initialization
	TEntry::Create_HashFunction ( );                       
	bCheckerBoard = TRUE; 
	g_nMoves = 0;
	}
if (g_nMoves > 500) g_nMoves = 0;
g_nMoves++;
g_CBoard.StartPosition( (info&1) );
g_sInfo = str;
g_pbPlayNow = playnow;
AddRepBoard ( TEntry::HashBoard (g_CBoard), g_nMoves);

int i;
for (i = 0; i < 64; i++)
	g_CBoard.Sqs [ BoardLoc [ i ] ] = ConvertFromCB [ board[i%8][7-i/8] ];
g_CBoard.Sqs[0] = INVALID;
g_CBoard.SideToMove = color ^ 3;
g_CBoard.SetFlags();

// Work around for a bug in checkerboard not sending reset
static int LastTotal = 0;
if ( (g_CBoard.nBlack + g_CBoard.nWhite) > LastTotal) 
	{g_nMoves = 0;
	 nDraw = 0;}
LastTotal = g_CBoard.nBlack + g_CBoard.nWhite;

fMaxSeconds = (float)maxtime *.985f;
int Eval = ComputerMove ( g_CBoard.SideToMove, g_CBoard );

for (i = 0; i < 64; i++)
   if (BoardLoc[i]>0 && g_CBoard.Sqs [ BoardLoc[i] ] != INVALID) 
		board[i%8][7-i/8] = ConvertToCB [ g_CBoard.Sqs [ BoardLoc[i] ] ];
AddRepBoard ( TEntry::HashBoard (g_CBoard), g_nMoves);

// Fixme: Don't reset for released version
int retVal = 3;
if ((Eval > 320 && g_CBoard.SideToMove == BLACK) || (Eval < -320 && g_CBoard.SideToMove == WHITE)) retVal = 1;
if ((Eval > 320 && g_CBoard.SideToMove == WHITE) || (Eval < -320 && g_CBoard.SideToMove == BLACK)) retVal = 2;
if ((g_nMoves > 90 && abs (Eval) < 11) || (g_nMoves > 150 && abs(Eval) < 50) ) nDraw++; else nDraw = 0;
if (nDraw >= 8) retVal = 0;

return retVal;
}

int WINAPI enginecommand(char str[256], char reply[1024])
{
	char command[256],param1[256],param2[256];
	char *stopstring;
	
	sscanf(str,"%s %s %s",command,param1,param2);

	if(strcmp(command,"name")==0)
		{
		sprintf(reply, g_sNameVer);
		return 1;
		}
	if(strcmp(command,"about")==0)
		{
	    sprintf(reply,"%s\n\nby Jonathan Kreuzer", g_sNameVer);
		return 1;
		}

	if(strcmp(command,"set")==0)
		if(strcmp(param1,"hashsize")==0)
			{
			int nMegs = strtol( param2, &stopstring, 10 );
			if (nMegs < 1) return 0;
			if (nMegs > 128) nMegs = 128;
			HASHTABLESIZE = nMegs * (1000000 / 12);
			if (TTable) free (TTable);
			TTable = (TEntry *) malloc( sizeof (TEntry) * HASHTABLESIZE + 2);

			return 1;
			}
	if(strcmp(command,"get")==0)
		{
		if(strcmp(param1,"hashsize")==0)
			{
			sprintf (reply, "%d", HASHTABLESIZE / (1000000 / 12));
			return 1;
			}
		if(strcmp(param1,"protocolversion")==0)
			{
			sprintf(reply,"2");
			return 1;
			}
		if(strcmp(param1,"gametype")==0)
			{
			sprintf(reply,"21");
			return 1;
			}
		}
	strcpy (reply, "?");
	return 0;
}